#include <xorhack.h>	// just for the syscall

// 
// These nice defines can be found in IBM's CBEA Programming Handbook, chapter 11.8
//
#define HV_Success	0
#define HV_Hardware	-1	// hardware error
#define HV_Function	-2	// function not supported
#define HV_Privilege	-3	// not privileged
#define HV_Parameter	-4	// Partition violation

// defines from wiki.ps2dev.org
#define HV_Access	-5	// Access violation
#define HV_No_Entry	-6	// no entry in partition table
#define HV_Duplicate	-7	// duplicate entry
#define HV_Busy		-9	// device is busy
#define HV_Wrong_State	-11	// is in wrong state
#define HV_Illegal_Par	-17	// illegal parameter value
#define HV_No_Implemen	-20	// function not implemented


//
// Hypervisor system call wrappers -- common stuff
//
int HV_get_version_info( u64* v1 );
int HV_get_logical_partition_id( u64* v1 );
int HV_get_logical_ppe_id( u64* v1 );
int HV_get_virtual_adress_space_id_of_ppe( u64 ppe_id, u64* v1 );
int HV_map_htab( u64 lpar, u64* v1 );

//
// Hypervisor system call wrappers -- repository
//
int HV_create_repository_node_value( u64 key1, u64 key2, u64 key3, u64 key4,
                                  u64 v1, u64 v2 );
int HV_get_repository_node_value( u64 p_id, u64 key1, u64 key2, u64 key3, u64 key4, 
                                  u64* v1, u64* v2 );
int HV_modify_repository_node_value( u64 key1, u64 key2, u64 key3, u64 key4,
                                  u64 v1, u64 v2 );
int HV_remove_repository_node_value( u64 key1, u64 key2, u64 key3, u64 key4 );

//
// Hypervisor system call wrappers -- SPU
//
int HV_construct_logical_spe( u64 shift1, u64 shift2, u64 shift3, u64 shift4, u64 shift5, 
                              u64 vas_id, u64 mode,
                              u64* priv2adr, u64* problphys, u64* LS_store, u64* dummy,
                              u64* shadowadr, u64* spe_id );
int HV_destruct_logical_spe( u64 spe_id );
int HV_enable_logical_spe( u64 spe_id, u64 res_id );
int HV_disable_logical_spe( u64 spe_id, u64 mode );

//
// HV calls common error message display
//
void HV_error( int errno );

