//
// test hypervisor call
//

#include <stdio.h>
#include <xorhack.h>
#include "HV_interface.h"

int main()
{
   u64 v1, v2;
   u64 status;
   char s[5];  // output version in readable form

   if( xorhack_init() )
   {
	printf("XH init error\n");
	return -1;
   }

   // do the HV call
   status = HV_map_htab( 0, &v1 );  // works with 0 and 2


   if ( status == HV_Success )
   {
      printf("HTAB at: %#llx\n", v1 );
   }
   else
      HV_error( status );
   
   if( xorhack_free() )
   {
       printf("XH free error\n");
       return -1;
   }

   return 0;
}
